#!/bin/bash
# Instalador criado por Francisco Pedro da Costa Filho
# Criado com base no tutorial de meu amigo Rodrigo Minelli, disponivel em:
# www.biazus.com/forum/viewtopic.php?f=6&t=636&p=5303#p5303
# Adaptado ao Big Linux 5 alpha3 por Cristiano Costa Maia / big4beta4@gmail.com

# teste de usuario root -----------------------------------------------------------------------------
if [ $UID != 0 ] ; then
clear
echo "#############################################################################"
echo "#                   INSTALADOR DO THUNDER CACHE                             #"
echo "#############################################################################"
echo "#                                                                           #"
echo "#      O INSTALADOR TEM QUE SEM ABERTO COMO ROOT USE O SUDO                 #"
echo "#                                                                           #"
echo "#############################################################################"
echo ""
else



apt-get update


tar xvfz /tmp/thundercache.tar.gz -C /
chmod a+x /usr/local/sbin/thunder
mkdir /var/log/thunder
mkdir /var/tmp/thunder
mkdir /var/run/thunder
chmod a+rwx /var/log/thunder
chmod a+rwx /var/tmp/thunder
chmod a+rwx /var/run/thunder
chmod a+x /etc/init.d/thunder
touch /etc/thunder/whitelist
touch /etc/thunder/blacklist
mkdir /thunder
chmod a+rwx /thunder
chown -R www-data /thunder/
chmod -R 777 /thunder/
umask 000 /thunder/
echo "extension=pdo.so" >> /etc/php5/apache2/php.ini
echo "extension=pdo_sqlite.so" >> /etc/php5/apache2/php.ini
sleep 3
ln -s /etc/thunder/thunder.php /var/www/thunder.php
ln -s /etc/thunder/thunder.css /var/www/thunder.css
update-rc.d thunder defaults
echo "vm.swappiness=10" >> /etc/sysctl.conf

# configura o thunder squid.conf -------------------------------------------------------------------------------------------------
if [ -d /usr/local/mkauth ]
then
echo "
# redirecionamento thunder 3.x - REGEX
acl thunder_lst url_regex -i \"/etc/thunder/thunder.lst\"
cache deny thunder_lst
cache_peer 127.0.0.1 parent 8080 0 proxy-only no-digest
dead_peer_timeout 2 seconds
cache_peer_access 127.0.0.1 allow thunder_lst
cache_peer_access 127.0.0.1 deny all" >> /etc/squid3/squid.conf
else
echo "
# SQUID PARA THUNDER CACHE 

http_port 3128 transparent 
visible_hostname mk-auth
icp_port 0

# cache de ip acessados
ipcache_size 1024
ipcache_low 90
ipcache_high 95

fqdncache_size 1024

# arquivos de Log retirados para melhor desempenho
access_log /var/log/squid3/access.log
cache_access_log /dev/null
cache_log /dev/null
cache_store_log /dev/null

# tamanho maximo do cache em memoria ram
cache_mem 256 MB
cache_swap_low 90
cache_swap_high 95

# tamanho maximo de arquivo que o cache irar guardar
maximum_object_size 40 MB
minimum_object_size 0 KB
maximum_object_size_in_memory  40 KB

# diretorio onde serao ficarao armazenado o cache das paginas. 
# O 5000 MBs do HD que sera reservado para o meu cache.
cache_dir aufs /var/spool/squid3 10000 16 256

# redirecionamento thunder 3.x - REGEX
acl thunder_lst url_regex -i \"/etc/thunder/thunder.lst\"
cache deny thunder_lst
cache_peer 127.0.0.1 parent 8080 0 proxy-only no-digest
dead_peer_timeout 2 seconds
cache_peer_access 127.0.0.1 allow thunder_lst
cache_peer_access 127.0.0.1 deny all

# toda a internet
acl todos src 0.0.0.0/0.0.0.0

# redes invalidas, nao sao da internet
acl rede src 127.0.0.1/32 5.0.0.0/8 169.254.0.0/16 192.168.0.0/16 10.0.0.0/8 172.16.0.0/16 172.17.0.0/16 172.18.0.0/16 172.19.0.0/16 172.20.0.0/16 172.21.0.0/16 172.22.0.0/16 172.23.0.0/16 172.24.0.0/16 172.25.0.0/16 172.26.0.0/16 172.27.0.0/16 172.28.0.0/16 172.29.0.0/16 172.30.0.0/16 172.31.0.0/16

acl manager proto cache_object
acl localhost src 127.0.0.1/32
acl to_localhost dst 127.0.0.0/32
acl SSL_ports port 443 563
acl Safe_ports port 80
acl Safe_ports port 21
acl Safe_ports port 443
acl Safe_ports port 563
acl Safe_ports port 70
acl Safe_ports port 210
acl Safe_ports port 280
acl Safe_ports port 488
acl Safe_ports port 591
acl Safe_ports port 777
acl Safe_ports port 901
acl Safe_ports port 1025-65535
acl CONNECT method CONNECT

http_access allow manager localhost
http_access deny manager
http_access deny !Safe_ports
http_access deny CONNECT !SSL_ports
http_access allow rede
http_access deny todos

# usuario que executa o servidor proxy 
cache_effective_user proxy 
cache_effective_group proxy



coredump_dir /var/spool/squid3

client_persistent_connections off
server_persistent_connections off

request_timeout 30 seconds
pconn_timeout 120 seconds" > /etc/squid3/squid.conf
fi

# fim da instalacao --------------------------------------------------------------------------------------------
clear
echo "#############################################################################"
echo "#                   INSTALADOR DO THUNDER CACHE                             #"
echo "#############################################################################"
echo "#                                                                           #"
echo "#                 INSTALACAO CONCLUIDA COM SUCESSO                          #"
echo "#                        REINICIE O SERVIDOR                                #"
echo "#                                                                           #"
echo "#############################################################################"
echo ""

fi
